

    #include <MEGA32.h>
    #include <main.h>
    #include <interface.h>
    #include <stdio.h>
    #include <stdlib.h>
    #include <math.h>
    #include <delay.h>
    #include <sleep.h> 
    #include <stdint.h>
    #include <io.h> 
    
    #define JTD 7
//    #define SEL  
//    #define STAGEA
//    #define STAGEB

    // GLOBAL VARIABLES

 //  unsigned int i;
    unsigned char statusreg,Id; 
    unsigned int value,value1, mode, conf, adc,RawData, WaveFreq=125,WavePhase; 
    unsigned int RawData;
    float v,v1,Vr,Vg,v5,v6,v7,Analog_Voltage,v2;  
    int m,n,Newvalue1,Phase7,Phase6,Phase5,Phase,Newvalue;  
  

    
    //Timer
    unsigned long unixTime = 0;
   //  unsigned int ms = 0;
    unsigned char now = 0;
    unsigned int logInt = 0;
    unsigned char flag = 1;
  //  unsigned int delay = 125;

    //Status
   // unsigned char state = 0;
    unsigned char debug = 0;
    unsigned int status = 0x0010;

    //Measured
//    char adcStatus;
//    char adcStatus1;
//    unsigned int adcMode;
//    unsigned int adcConfig;
//    unsigned char adcId;
//    unsigned int battVoltRaw;
//    unsigned int battVolt;
//    unsigned int analogVoltRaw;
//    unsigned int analogVolt;
//    unsigned int tempRaw;                                  
//    unsigned int temp;
//    unsigned int pressRaw;
//    unsigned int press = 0; 
//     unsigned int data;

    unsigned int vcc;
    unsigned int analogVoltPos;
    unsigned int analogVoltNeg;
    unsigned int supplyVoltage;

    //Flash
//    char manufId;                      
//    char memType;
//    char memCap;

    //External variables
    unsigned char Command;
    //ADC, stage1, stage2;
    unsigned int  Param=125;
    extern unsigned char rx_counter0;

    //Read microcontroller ADC
    unsigned int ReadMcAdc(unsigned char adcInput)
    {

    ADMUX=adcInput | (ADC_VREF_TYPE & 0xff);
    // Delay needed for the stabilization of the ADC input voltage
    delay_us(10);
    // Start the AD conversion
    ADCSRA|=0x40;
    // Wait for the AD conversion to complete
    while ((ADCSRA & 0x10)==0);
    ADCSRA|=0x10;
    return ADCW;
    }

    //Initialize registers
    void init(void){

    #asm("cli");        //Disable global interrupt

    // Input/Output Ports initialization
    // Port B initialization
     
    // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
    // PORTB=(0<<PB0)|(0<<PB1)|(0<<PB2)|(0<<PB3)|(0<<PB4)|(0<<PB5)|(0<<PB6)|(0<<PB7);
    PORTB=0x04;
    // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
    DDRB=0xBF;

    // Port C initialization
    // Func7=out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
    // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
    PORTC=0x40;
    DDRC=0xC3;

                               
    // Port D initialization
     
    // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
    PORTD=0xD4;
    // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In
    DDRD=0xFC;

    // USART initialization
    // Communication Parameters: 8 Data, 1 Stop, No Parity
    // USART Receiver: On
    // USART Transmitter: On
    // USART0 Mode: Asynchronous
    // USART Baud Rate: 38400
    UCSRC=0x86;
    UBRRH=0x00;
    UBRRL=0x19;
    UCSRA=0x00;
    UCSRB=0xD8;
    //UCSRC=0x86;


    // ADC initialization
    // ADC Clock frequency: 1000 kHz
    // ADC Voltage Reference: AREF pin
    // ADC Auto Trigger Source: None
    // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
    // ADC4: On, ADC5: On
    //DIDR0=0x00;
    ADMUX=ADC_VREF_TYPE & 0xff;
    ADCSRA=0x84;

    // SPI initialisation
    // SPI clock rate fck/16
    // SPI master
    // SPI MSB first
    // SPI CPOL = 1, CPHA = 1
    SPCR=0x5D;
    //PORTB.1 = 1;    //Flash CS high
    PORTB.3 = 1;    //ADC CS high

    //Global enable interrupts
    #asm("sei")
    }

    // Execute commands
    void runCom(void){
                       
        switch(Command){
                      
            case(NO_COM):
                Command = 0;
                break;
            
            case(SCAN):  
                 while (1)
                 {
                 continous();
                  return; 
                 }
                  Command = 0;
                  break;

            case(WGF):
                  if(Param < 500)
                    SetWGFreq(Param);  
                    WaveFreq = Param; 
                    Command = 0;
                  break; 
                
            case(WGP):
                  if(Param < 4095) 
                    SetWGPhase1(Param); //shifting the signal with a value.  
                    WavePhase=Param;
                  Command = 0;
                  break;   
            
            default:
                 Command = 0;
                 break;   
        }
    }




    void main(void){
                
            int Flag = 0;
      status = 0x0010;
        
        
           init();                                     //Initialize controller
           // Command = WGF;                            //Initialize waveformgenerator 125 kHz
           Command = INF;    
          
          //  SetWGFreq(125);                   
           debug = 0;                                  //Controls output during motor running      
            // MCUCSR =(1<<7);
            // MCUCSR =(1<<7);

        while (1){   
              SetWGFreq(125);
            if(rx_counter0) getCom();
            if(Command)     runCom(); 

            #asm("WDR");        //Reset WD timer 
            
        } // EOF "while(1)"   
        
        
 
    } // EOF "main(void)"




 unsigned int continous(void){  

   phaseshift(&v, &Phase); 
   
     return 0;                         
 }